#include "targetsocket.h"

risc::TargetSocket::TargetSocket():
  Socket(NULL, NULL, TargetSocketType), 
  registered_b_transport_(NULL),
  registered_get_dmi(NULL),
  registered_nb_transport_fw_(NULL)
{ }

risc::TargetSocket::TargetSocket(SgVariableDefinition *ast_node, Class *parent):
  Socket(ast_node, parent, TargetSocketType), 
  registered_b_transport_(NULL),
  registered_get_dmi(NULL),
  registered_nb_transport_fw_(NULL)
{ }

void risc::TargetSocket::get_mapped_sockets(
	std::set<risc::Socket*> &mapped_sockets)
{
	risc::Socket::helper_get_mapped_sockets(mapped_sockets, false);
}


void risc::TargetSocket::register_b_transport(
	SgFunctionDeclaration* func_decl)
{
	is_end_ = true;
	registered_b_transport_ = func_decl;
}

SgFunctionDeclaration* risc::TargetSocket::get_registered_bt()
{
	return registered_b_transport_;
}


void risc::TargetSocket::register_get_dmi(
	SgFunctionDeclaration* func_decl)
{
	is_end_ = true;
	registered_get_dmi = func_decl;
}

SgFunctionDeclaration* risc::TargetSocket::get_registered_get_dmi()
{
	return registered_get_dmi;
}

void risc::TargetSocket::register_nb_transport_fw(
	SgFunctionDeclaration* func_decl)
{
	is_end_ = true;
	registered_nb_transport_fw_ = func_decl;
}

SgFunctionDeclaration* risc::TargetSocket::get_registered_nb_transport_fw()
{
	return registered_nb_transport_fw_;
}


/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
