#include "function_annotation_attributes.h"

risc::sg::FunctionAnnotationAttributes::FunctionAnnotationAttributes(
    FunctionAnnotationAttributes *func_attributes):
  function_name_(func_attributes->function_name_),
  is_conflict_free_(func_attributes->is_conflict_free_),
  wait_type_(func_attributes->wait_type_)
{
  annotated_time_ = new AnnotatedTime();
  annotated_time_->units_ = func_attributes->annotated_time_->units_;
  annotated_time_->magnitude_ = func_attributes->annotated_time_->magnitude_;
  annotated_time_->event_notification_
    = func_attributes->annotated_time_->event_notification_;
  annotated_time_->sc_zero_time_
    = func_attributes->annotated_time_->sc_zero_time_;
}

risc::sg::FunctionAnnotationAttributes::FunctionAnnotationAttributes(
    FunctionAnnotation *annotation):
  function_name_(annotation->function_name_),
  is_conflict_free_(annotation->is_conflict_free_),
  wait_type_(annotation->wait_type_),
  annotated_time_(annotation->annotated_time_)
{ }

risc::sg::FunctionAnnotationAttributes::FunctionAnnotationAttributes(
    std::string function_name,
    bool is_conflict_free,
    WAIT_CONSTRUCT wait_type,
    AnnotatedTime *annotated_time):
  function_name_(function_name),
  is_conflict_free_(is_conflict_free),
  wait_type_(wait_type),
  annotated_time_(annotated_time)
{ }

bool risc::sg::FunctionAnnotationAttributes::has_boundary()
{
  return wait_type_ != NO_WAIT;
}

bool risc::sg::FunctionAnnotationAttributes::operator==(
    const FunctionAnnotationAttributes &other)
{
  return (is_conflict_free_ == other.is_conflict_free_) &&
      (wait_type_ == other.wait_type_) &&
      (*annotated_time_ == *(other.annotated_time_));
}

bool risc::sg::FunctionAnnotationAttributes::operator!=(
    const FunctionAnnotationAttributes &other)
{
  return !(*this == other);
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
