#include <stdio.h>
#include "systemc.h"
#define LOOP 1000
SC_MODULE(M1)
{

public:
  int data[2];
  sc_event e;
  void producer(){
    for(int i=0; i<100; ++i)
    {
        data[i & 1] = i;
        e.notify(SC_ZERO_TIME);
        wait(SC_ZERO_TIME);
    }
    
  }

  void consumer(){
    int i=0; 
    while(true)
    {
        wait(e);
        int res = data[i & 1];
        assert(res == i);// std::cout << "res = " << res << ", but should be " << i << endl;
        ++i;
    }
  }

  SC_CTOR(M1){
    SC_THREAD(producer)
    SC_THREAD(consumer)
  }
};


SC_MODULE(Top)
{
  M1 m1;
	
  SC_CTOR(Top)
  : m1("m1")
  {}
};
	
int sc_main(int argc, char* argv[])
{
  Top top("top");
  sc_start();
  return 0;
}

// EOF
