// bug20190217.cc
// replication of bug in EM's main_risc.cpp (reported by EM 02/14/19)

#include <systemc>

typedef const char *String;
//typedef int Mat;
struct Mat
{
    unsigned char image[100];

    Mat(void)
    {
        for (int i = 0; i < 100; i++)
            image[i] = 0;
    }

    Mat& operator=(const Mat& copy)
    {
        for (int i = 0; i < 100; i++)
            image[i] = copy.image[i];
        return *this;
    }

    unsigned char& operator[](const int index)
    {
        return image[index];
    }

    operator unsigned char*()
    {
        return image;
    }
};

class concat_4x1 : public sc_core::sc_module
{

public:
  sc_core::sc_fifo_in<Mat>  blob_in_0;
  sc_core::sc_fifo_in<Mat>  blob_in_1;
  sc_core::sc_fifo_in<Mat>  blob_in_2;
  sc_core::sc_fifo_in<Mat>  blob_in_3;
  sc_core::sc_fifo_out<Mat> blob_out;

  SC_HAS_PROCESS(concat_4x1);

  concat_4x1(sc_core::sc_module_name n_,
             String name_): sc_core::sc_module(n_),
                            name(name_)
  {
    SC_THREAD(main);
  }

  void main();

private:
  String name;
};

void concat_4x1::main()
{
  std::vector<Mat> inpVec(4), outVec;

  // EM's crash
  inpVec[0] = blob_in_0.read();
  inpVec[1] = blob_in_1.read();
  inpVec[2] = blob_in_2.read();
  inpVec[3] = blob_in_3.read();

  // RD's variation
  Mat tmp;
  tmp = blob_in_0.read(); inpVec[0]=tmp;
  tmp = blob_in_1.read(); inpVec[1]=tmp;
  tmp = blob_in_2.read(); inpVec[2]=tmp;
  tmp = blob_in_3.read(); inpVec[3]=tmp;

  outVec = inpVec; //run(inpVec, outVec);

  Mat& out = outVec[0];
  blob_out.write(out);
}

SC_MODULE(Top)
{
	sc_core::sc_fifo<Mat> q0, q1, q2, q3, q4;

	concat_4x1 concat_4x1_1;

	void before_end_of_elaboration(){
	   concat_4x1_1.blob_in_0.bind(q0);
	   concat_4x1_1.blob_in_1.bind(q1);
	   concat_4x1_1.blob_in_2.bind(q2);
	   concat_4x1_1.blob_in_3.bind(q3);
	   concat_4x1_1.blob_out.bind(q4);
	}

	SC_CTOR(Top)
	:q0("q0",1)
	,q1("q1",1)
	,q2("q2",1)
	,q3("q3",1)
	,q4("q4",1)
	,concat_4x1_1("concat_4x1_1", "")
	{}
};

Top top("top");

int sc_main(int argc, char* argv[])
{
	sc_core::sc_start();
	return 0;
}

// EOF
