/* bug20190328.cc:
 * was CannyA9_step3.cpp, ECPS203 Assignment 9 step 3
 * cut down to structural skeleton
 * 3/28/19, RD */

#include <stdio.h>
#include "systemc.h"

#define COLS 16
#define ROWS 9
#define SIZE COLS*ROWS
#define IMG_NUM  20
#define AVAIL_IMG 1
#define WINSIZE 21

typedef struct Image_s
{
	unsigned char img[SIZE];

	Image_s(void)
	{
	   for (int i=0; i<SIZE; i++)
	   {
	      img[i] = 0;
	   }
	}

	Image_s& operator=(const Image_s& copy)
	{
	   for (int i=0; i<SIZE; i++)
	   {
	      img[i] = copy.img[i];
	   }
	   return *this;
	}

	operator unsigned char*()
	{
	   return img;
	}

	unsigned char& operator[](const int index)
	{
	   return img[index];
	}
} IMAGE;

typedef struct Simage_s
{
	short int simg[SIZE];

	Simage_s(void)
	{
	   for (int i=0; i<SIZE; i++)
	   {
	      simg[i] = 0;
	   }
	}

	Simage_s& operator=(const Simage_s& copy)
	{
	   for (int i=0; i<SIZE; i++)
	   {
	      simg[i] = copy.simg[i];
	   }
	   return *this;
	}

	operator short int*()
	{
	   return simg;
	}

	short int& operator[](const int index)
	{
	   return simg[index];
	}
} SIMAGE;

typedef struct Fkernal_s
{
	float fkernal[WINSIZE];

	Fkernal_s(void)
	{
	   for (int i=0; i<WINSIZE; i++)
	   {
	      fkernal[i] = 0;
	   }
	}

	Fkernal_s& operator=(const Fkernal_s& copy)
	{
	   for (int i=0; i<WINSIZE; i++)
	   {
	      fkernal[i] = copy.fkernal[i];
	   }
	   return *this;
	}

	operator float*()
	{
	   return fkernal;
	}

	float& operator[](const int index)
	{
	   return fkernal[index];
	}
} FKERNAL;

typedef struct Fimage_s
{
	float fimg[SIZE];

	Fimage_s(void)
	{
	   for (int i=0; i<SIZE; i++)
	   {
	      fimg[i] = 0;
	   }
	}

	Fimage_s& operator=(const Fimage_s& copy)
	{
	   for (int i=0; i<SIZE; i++)
	   {
	      fimg[i] = copy.fimg[i];
	   }
	   return *this;
	}

	operator float*()
	{
	   return fimg;
	}

	float& operator[](const int index)
	{
	   return fimg[index];
	}
} FIMAGE;

class i_IMAGE_sender: virtual public sc_interface
{
    public:
        virtual void write(IMAGE&) = 0;
};

class i_IMAGE_receiver: virtual public sc_interface
{
    public:
        virtual void read(IMAGE&) = 0;
};

class c_IMAGE_fifo: public sc_channel, public i_IMAGE_sender, public i_IMAGE_receiver
{
    public:
        c_IMAGE_fifo(sc_module_name name, int size_ = 16): sc_channel(name)
        {
            size = size_;
            buf = new IMAGE[size];
            reset();
        }

        ~c_IMAGE_fifo()
        {
            delete [] buf;
        }

        int num_available() const
        {
            return size - free_slots;
        }

        int num_free() const
        {
            return free_slots;
        }

        void write(IMAGE& X)
        {
            while (num_free() == 0)
                wait(data_read_event);
            buf[wi] = X;
            wi = (wi+1) % size;
            free_slots --;
            data_written_event.notify(SC_ZERO_TIME);
        }

        void read(IMAGE& Y)
        {
            while (num_available() == 0)
                wait(data_written_event);
            Y = buf[ri];
            ri = (ri+1) % size;
            free_slots ++;
            data_read_event.notify(SC_ZERO_TIME);
        }

        void reset()
        {
            free_slots = size;
            ri = 0;
            wi = 0;
        }

    private:
        int size;
        IMAGE *buf;
        int free_slots;
        int ri;
        int wi;

        sc_event data_read_event;
        sc_event data_written_event;
};

class i_SIMAGE_sender: virtual public sc_interface
{
    public:
        virtual void write(SIMAGE&) = 0;
};

class i_SIMAGE_receiver: virtual public sc_interface
{
    public:
        virtual void read(SIMAGE&) = 0;
};

class c_SIMAGE_fifo: public sc_channel, public i_SIMAGE_sender, public i_SIMAGE_receiver
{
    public:
        c_SIMAGE_fifo(sc_module_name name, int size_ = 16): sc_channel(name)
        {
            size = size_;
            buf = new SIMAGE[size];
            reset();
        }

        ~c_SIMAGE_fifo()
        {
            delete [] buf;
        }

        int num_available() const
        {
            return size - free_slots;
        }

        int num_free() const
        {
            return free_slots;
        }

        void write(SIMAGE& X)
        {
            while (num_free() == 0)
                wait(data_read_event);
            buf[wi] = X;
            wi = (wi+1) % size;
            free_slots --;
            data_written_event.notify(SC_ZERO_TIME);
        }

        void read(SIMAGE& Y)
        {
            while (num_available() == 0)
                wait(data_written_event);
            Y = buf[ri];
            ri = (ri+1) % size;
            free_slots ++;
            data_read_event.notify(SC_ZERO_TIME);
        }

        void reset()
        {
            free_slots = size;
            ri = 0;
            wi = 0;
        }

    private:
        int size;
        SIMAGE *buf;
        int free_slots;
        int ri;
        int wi;

        sc_event data_read_event;
        sc_event data_written_event;
};

class i_FKERNAL_sender: virtual public sc_interface
{
    public:
        virtual void write(FKERNAL&) = 0;
};

class i_FKERNAL_receiver: virtual public sc_interface
{
    public:
        virtual void read(FKERNAL&) = 0;
};

class c_FKERNAL_fifo: public sc_channel, public i_FKERNAL_sender, public i_FKERNAL_receiver
{
    public:
        c_FKERNAL_fifo(sc_module_name name, int size_ = 16): sc_channel(name)
        {
            size = size_;
            buf = new FKERNAL[size];
            reset();
        }

        ~c_FKERNAL_fifo()
        {
            delete [] buf;
        }

        int num_available() const
        {
            return size - free_slots;
        }

        int num_free() const
        {
            return free_slots;
        }

        void write(FKERNAL& X)
        {
            while (num_free() == 0)
                wait(data_read_event);
            buf[wi] = X;
            wi = (wi+1) % size;
            free_slots --;
            data_written_event.notify(SC_ZERO_TIME);
        }

        void read(FKERNAL& Y)
        {
            while (num_available() == 0)
                wait(data_written_event);
            Y = buf[ri];
            ri = (ri+1) % size;
            free_slots ++;
            data_read_event.notify(SC_ZERO_TIME);
        }

        void reset()
        {
            free_slots = size;
            ri = 0;
            wi = 0;
        }

    private:
        int size;
        FKERNAL *buf;
        int free_slots;
        int ri;
        int wi;

        sc_event data_read_event;
        sc_event data_written_event;
};

class i_FIMAGE_sender: virtual public sc_interface
{
    public:
        virtual void write(FIMAGE&) = 0;
};

class i_FIMAGE_receiver: virtual public sc_interface
{
    public:
        virtual void read(FIMAGE&) = 0;
};

class c_FIMAGE_fifo: public sc_channel, public i_FIMAGE_sender, public i_FIMAGE_receiver
{
    public:
        c_FIMAGE_fifo(sc_module_name name, int size_ = 16): sc_channel(name)
        {
            size = size_;
            buf = new FIMAGE[size];
            reset();
        }

        ~c_FIMAGE_fifo()
        {
            delete [] buf;
        }

        int num_available() const
        {
            return size - free_slots;
        }

        int num_free() const
        {
            return free_slots;
        }

        void write(FIMAGE& X)
        {
            while (num_free() == 0)
                wait(data_read_event);
            buf[wi] = X;
            wi = (wi+1) % size;
            free_slots --;
            data_written_event.notify(SC_ZERO_TIME);
        }

        void read(FIMAGE& Y)
        {
            while (num_available() == 0)
                wait(data_written_event);
            Y = buf[ri];
            ri = (ri+1) % size;
            free_slots ++;
            data_read_event.notify(SC_ZERO_TIME);
        }

        void reset()
        {
            free_slots = size;
            ri = 0;
            wi = 0;
        }

    private:
        int size;
        FIMAGE *buf;
        int free_slots;
        int ri;
        int wi;

        sc_event data_read_event;
        sc_event data_written_event;
};

typedef int INT;

class i_INT_sender: virtual public sc_interface
{
    public:
        virtual void write(INT&) = 0;
};

class i_INT_receiver: virtual public sc_interface
{
    public:
        virtual void read(INT&) = 0;
};

class c_INT_fifo: public sc_channel, public i_INT_sender, public i_INT_receiver
{
    public:
        c_INT_fifo(sc_module_name name, int size_ = 16): sc_channel(name)
        {
            size = size_;
            buf = new INT[size];
            reset();
        }

        ~c_INT_fifo()
        {
            delete [] buf;
        }

        int num_available() const
        {
            return size - free_slots;
        }

        int num_free() const
        {
            return free_slots;
        }

        void write(INT& X)
        {
            while (num_free() == 0)
                wait(data_read_event);
            buf[wi] = X;
            wi = (wi+1) % size;
            free_slots --;
            data_written_event.notify(SC_ZERO_TIME);
        }

        void read(INT& Y)
        {
            while (num_available() == 0)
                wait(data_written_event);
            Y = buf[ri];
            ri = (ri+1) % size;
            free_slots ++;
            data_read_event.notify(SC_ZERO_TIME);
        }

        void reset()
        {
            free_slots = size;
            ri = 0;
            wi = 0;
        }

    private:
        int size;
        INT *buf;
        int free_slots;
        int ri;
        int wi;

        sc_event data_read_event;
        sc_event data_written_event;
};

typedef sc_time SCTIME;

class i_SCTIME_sender: virtual public sc_interface
{
    public:
        virtual void write(SCTIME&) = 0;
};

class i_SCTIME_receiver: virtual public sc_interface
{
    public:
        virtual void read(SCTIME&) = 0;
};

class c_SCTIME_fifo: public sc_channel, public i_SCTIME_sender, public i_SCTIME_receiver
{
    public:
        c_SCTIME_fifo(sc_module_name name, int size_ = 16): sc_channel(name)
        {
            size = size_;
            buf = new SCTIME[size];
            reset();
        }

        ~c_SCTIME_fifo()
        {
            delete [] buf;
        }

        int num_available() const
        {
            return size - free_slots;
        }

        int num_free() const
        {
            return free_slots;
        }

        void write(SCTIME& X)
        {
            while (num_free() == 0)
                wait(data_read_event);
            buf[wi] = X;
            wi = (wi+1) % size;
            free_slots --;
            data_written_event.notify(SC_ZERO_TIME);
        }

        void read(SCTIME& Y)
        {
            while (num_available() == 0)
                wait(data_written_event);
            Y = buf[ri];
            ri = (ri+1) % size;
            free_slots ++;
            data_read_event.notify(SC_ZERO_TIME);
        }

        void reset()
        {
            free_slots = size;
            ri = 0;
            wi = 0;
        }

    private:
        int size;
        SCTIME *buf;
        int free_slots;
        int ri;
        int wi;

        sc_event data_read_event;
        sc_event data_written_event;
};

SC_MODULE(Stimulus){
	IMAGE imageout;
	sc_port<i_IMAGE_sender> ImgOut;
	sc_port<i_SCTIME_sender> StartTime;

	void main(void)
	{
	   int i=0, n=0;
	   sc_time t;

	   for(i=0; i<IMG_NUM; i++)
	   {
	      n = i % AVAIL_IMG;
	      // read imageout from file
	      ImgOut->write(imageout);
	      t = sc_time_stamp();
	      printf("%9s: Stimulus sent frame%3d.\n", t.to_string().c_str(), n+1);
	      StartTime->write(t);
	   }
	}

	SC_CTOR(Stimulus)
	{
	   SC_THREAD(main);
	}
};

SC_MODULE(Monitor){
	IMAGE imagein;
	sc_port<i_IMAGE_receiver> ImgIn;
	sc_port<i_SCTIME_receiver> StartTime;

	void main(void)
	{
	   int i, n;
	   sc_time t1,t2,t,t3,t_delay;

	   for(i=0; i<IMG_NUM; i++)
	   {
	      ImgIn->read(imagein);
		  StartTime->read(t1);
		  t2=sc_time_stamp();
		  t=t2-t1;
		  t_delay = t2-t3;
		  t3=t2;
	      n = i % AVAIL_IMG;
		  printf("%9s: Monitor received frame%3d with%9s delay.\n",
			t2.to_string().c_str(), n+1, t.to_string().c_str());
		  printf("%9s: %5.3f seconds after previous frame, %5.3f FPS.\n",
			t2.to_string().c_str(), t_delay.to_double()/1000000000000, 1000000000000/t_delay.to_double());
		// write imagein to file
	   }
	   printf("%9s: Monitor exits simulation.\n", t2.to_string().c_str());
	   sc_time expected_t(4548, SC_MS);
	   assert(t == expected_t);
	   sc_time expected_t_delay(272, SC_MS);
	   assert(t_delay == expected_t_delay);
	   sc_time expected_time(6109, SC_MS);
	   assert(sc_time_stamp() == expected_time);
	   sc_stop();
	}

	SC_CTOR(Monitor)
	{
	   SC_THREAD(main);
	}
};

SC_MODULE(DataIn)
{
	sc_port<i_IMAGE_receiver> ImgIn;
	sc_port<i_IMAGE_sender> ImgOut;
	IMAGE Image;

	void main()
	{
	   while(1)
	   {
	      ImgIn->read(Image);
	      ImgOut->write(Image);
	   }
	}

	SC_CTOR(DataIn)
	{
	   SC_THREAD(main);
	}
};

SC_MODULE(DataOut)
{
	sc_port<i_IMAGE_receiver> ImgIn;
	sc_port<i_IMAGE_sender> ImgOut;
	IMAGE Image;

	void main()
	{
	   while(1)
	   {
	      ImgIn->read(Image);
	      ImgOut->write(Image);
	   }
	}

	SC_CTOR(DataOut)
	{
	   SC_THREAD(main);
	}
};

SC_MODULE(Receive_Image)
{
	sc_port<i_IMAGE_receiver> ImgIn;
	sc_port<i_IMAGE_sender> ImgOut;
	IMAGE Image;

	void main()
	{
	   while(1)
	   {
	      wait(0,SC_MS);
	      ImgIn->read(Image);
	      ImgOut->write(Image);
	   }
	}

	SC_CTOR(Receive_Image)
	{
	   SC_THREAD(main);
	}
};

SC_MODULE(Gaussian_Kernel)
{
	sc_port<i_FKERNAL_sender> G_Out1,G_Out2;
	sc_port<i_INT_sender> C_Out1,C_Out2;

	sc_port<i_IMAGE_receiver> ImgIn;
	sc_port<i_IMAGE_sender> ImgOut;

	FKERNAL gaussian_kernel;
	int kernel_center;
	IMAGE Image;

	void main(void)
	{
	   int windowsize,
	       center;

	   while(1)
	   {
	      wait(0,SC_MS);
	      //make_gaussian_kernel(SIGMA, gaussian_kernel, &windowsize);
	      windowsize = 21;
	      center = windowsize / 2;
	      kernel_center = center;
	      ImgIn->read(Image);
	      ImgOut->write(Image);
	      G_Out1->write(gaussian_kernel);
	      G_Out2->write(gaussian_kernel);
	      C_Out1->write(kernel_center);
	      C_Out2->write(kernel_center);
	   }
	}

	SC_CTOR(Gaussian_Kernel)
	{
	   SC_THREAD(main);
	}
};

SC_MODULE(BlurX)
{
	sc_port<i_IMAGE_receiver> ImgIn;
	sc_port<i_FKERNAL_receiver> KernelIn,KernelIn_for_y;
	sc_port<i_INT_receiver> CenterIn,CenterIn_for_y;
	sc_port<i_FIMAGE_sender> TempimOut;
	sc_port<i_FKERNAL_sender> KernelOut_for_y;
	sc_port<i_INT_sender> CenterOut_for_y;

	IMAGE image;
	FKERNAL kernel,kernel_for_y;
	int center,center_for_y;
	FIMAGE tempim;
	sc_event data_received_event;
	sc_event_and_list main_continue;
	sc_event b0,b1,b2,b3;

	void BlurX_Slice0()
	{
	   while(1){
	      wait(data_received_event);
	      wait(240/4,SC_MS);
	      //blur_x(ROWS, COLS, ((ROWS/4)*0), ((ROWS/4)*1));
	      b0.notify(SC_ZERO_TIME);
	   }
	}
	void BlurX_Slice1()
	{
	   while(1){
	      wait(data_received_event);
	      wait(240/4,SC_MS);
	      //blur_x(ROWS, COLS, ((ROWS/4)*1), ((ROWS/4)*2));
	      b1.notify(SC_ZERO_TIME);
	   }
	}
	void BlurX_Slice2()
	{
	   while(1){
	      wait(data_received_event);
	      wait(240/4,SC_MS);
	      //blur_x(ROWS, COLS, ((ROWS/4)*2), ((ROWS/4)*3));
	      b2.notify(SC_ZERO_TIME);
	   }
	}
	void BlurX_Slice3()
	{
	   while(1){
	      wait(data_received_event);
	      wait(240/4,SC_MS);
	      //blur_x(ROWS, COLS, ((ROWS/4)*3), ((ROWS/4)*4));
	      b3.notify(SC_ZERO_TIME);
	   }
	}

	void before_end_of_elaboration()
	{
	   main_continue&=b0;
	   main_continue&=b1;
	   main_continue&=b2;
	   main_continue&=b3;
	}

	void main(void)
	{
	   while(1)
	   {
	      ImgIn->read(image);
	      KernelIn->read(kernel);
	      CenterIn->read(center);
	      KernelIn_for_y->read(kernel_for_y);
	      CenterIn_for_y->read(center_for_y);
	      data_received_event.notify(SC_ZERO_TIME);
	      wait(main_continue);
	      TempimOut->write(tempim);
	      KernelOut_for_y->write(kernel_for_y);
	      CenterOut_for_y->write(center_for_y);
	   }
	}

	SC_CTOR(BlurX)
	{
	   SC_THREAD(main);
	   SC_THREAD(BlurX_Slice0);
	   SC_THREAD(BlurX_Slice1);
	   SC_THREAD(BlurX_Slice2);
	   SC_THREAD(BlurX_Slice3);
	}
};

SC_MODULE(BlurY)
{
	sc_port<i_FKERNAL_receiver> KernelIn;
	sc_port<i_INT_receiver> CenterIn;
	sc_port<i_FIMAGE_receiver> TempimIn;
	sc_port<i_SIMAGE_sender> SmoothedimOut;

	FKERNAL kernel;
	int center;
	FIMAGE tempim;
	SIMAGE smoothedim;

	sc_event data_received_event;
	sc_event_and_list main_continue;
	sc_event b0,b1,b2,b3;
	void BlurY_Slice0()
	{
	   while(1){
	      wait(data_received_event);
	      wait(467/4,SC_MS);
	      //blur_y(ROWS, COLS, ((COLS/4)*0), ((COLS/4)*1));
	      b0.notify(SC_ZERO_TIME);
	   }
	}
	void BlurY_Slice1()
	{
	   while(1){
	      wait(data_received_event);
	      wait(467/4,SC_MS);
	      //blur_y(ROWS, COLS, ((COLS/4)*1), ((COLS/4)*2));
	      b1.notify(SC_ZERO_TIME);
	   }
	}
	void BlurY_Slice2()
	{
	   while(1){
	      wait(data_received_event);
	      wait(467/4,SC_MS);
	      //blur_y(ROWS, COLS, ((COLS/4)*2), ((COLS/4)*3));
	      b2.notify(SC_ZERO_TIME);
	   }
	}
	void BlurY_Slice3()
	{
	   while(1){
	      wait(data_received_event);
	      wait(467/4,SC_MS);
	      //blur_y(ROWS, COLS, ((COLS/4)*3), ((COLS/4)*4));
	      b3.notify(SC_ZERO_TIME);
	   }
	}

	void before_end_of_elaboration()
	{
	   main_continue&=b0;
	   main_continue&=b1;
	   main_continue&=b2;
	   main_continue&=b3;
	}

	void main(void)
	{
	   while(1)
	   {
	      TempimIn->read(tempim);
	      KernelIn->read(kernel);
	      CenterIn->read(center);
	      data_received_event.notify(SC_ZERO_TIME);
	      wait(main_continue);
	      SmoothedimOut->write(smoothedim);
	   }
	}

	SC_CTOR(BlurY)
	{
	   SC_THREAD(main);
	   SC_THREAD(BlurY_Slice0);
	   SC_THREAD(BlurY_Slice1);
	   SC_THREAD(BlurY_Slice2);
	   SC_THREAD(BlurY_Slice3);
	}
};

SC_MODULE(Gaussian_Smooth)
{
	sc_port<i_IMAGE_receiver> ImgIn;
	sc_port<i_SIMAGE_sender> SmoothedimOut;

	c_IMAGE_fifo img_q1,img_q2;
	c_FKERNAL_fifo knl_q1,knl_q2,knl_q3;
	c_FIMAGE_fifo tmp_q;
	c_INT_fifo int_q1,int_q2,int_q3;

	Receive_Image receiver;
	Gaussian_Kernel g_kernel;
	BlurX blurx;
	BlurY blury;

	SC_CTOR(Gaussian_Smooth)
	:receiver("receiver")
	,g_kernel("g_kernel")
	,blurx("blurx")
	,blury("blury")
	,img_q1("img_q1",1)
	,img_q2("img_q2",1)
	,knl_q1("knl_q1",1)
	,knl_q2("knl_q2",1)
	,knl_q3("knl_q3",1)
	,tmp_q("tmp_q",1)
	,int_q1("int_q1",1)
	,int_q2("int_q2",1)
	,int_q3("int_q3",1)
 	{
           receiver.ImgIn.bind(ImgIn);
           receiver.ImgOut.bind(img_q1);

	   g_kernel.ImgIn.bind(img_q1);
           g_kernel.C_Out1.bind(int_q1);
           g_kernel.C_Out2.bind(int_q2);
           g_kernel.G_Out1.bind(knl_q1);
           g_kernel.G_Out2.bind(knl_q2);
	   g_kernel.ImgOut.bind(img_q2);

           blurx.ImgIn.bind(img_q2);
           blurx.CenterIn.bind(int_q1);
           blurx.KernelIn.bind(knl_q1);
	   blurx.CenterIn_for_y.bind(int_q2);
           blurx.KernelIn_for_y.bind(knl_q2);
           blurx.TempimOut.bind(tmp_q);
	   blurx.CenterOut_for_y.bind(int_q3);
           blurx.KernelOut_for_y.bind(knl_q3);

           blury.CenterIn.bind(int_q3);
           blury.KernelIn.bind(knl_q3);
           blury.TempimIn.bind(tmp_q);
           blury.SmoothedimOut.bind(SmoothedimOut);
	}
};

SC_MODULE(Derivative_X_Y)
{
	sc_port<i_SIMAGE_receiver> SmoothedimIn;
	sc_port<i_SIMAGE_sender> XOut1, XOut2, YOut1, YOut2;
	SIMAGE smoothedim, delta_x, delta_y;

	void main(void)
	{
	   while(1)
	   {
	      SmoothedimIn->read(smoothedim);
	      wait(144,SC_MS);
	      //derivative_x_y(ROWS, COLS);
	      XOut1->write(delta_x);
	      XOut2->write(delta_x);
	      YOut1->write(delta_y);
	      YOut2->write(delta_y);
	   }
	}

	SC_CTOR(Derivative_X_Y)
	{
           SC_THREAD(main);
    	}
};

SC_MODULE(Magnitude_X_Y)
{
	sc_port<i_SIMAGE_receiver> XIn, YIn;
	sc_port<i_SIMAGE_sender> MagnitudeOut1, MagnitudeOut2;
	sc_port<i_SIMAGE_receiver> GradxIn_ByPass, GradyIn_ByPass;
	sc_port<i_SIMAGE_sender> GradxOut_ByPass, GradyOut_ByPass;
	SIMAGE delta_x, delta_y, magnitude;
	SIMAGE Gradx_ByPass,Grady_ByPass;

	void main(void)
	{
	   while(1)
	   {
	      XIn->read(delta_x);
	      YIn->read(delta_y);
	      GradxIn_ByPass->read(Gradx_ByPass);
	      GradyIn_ByPass->read(Grady_ByPass);
	      wait(153,SC_MS);
	      //magnitude_x_y(ROWS, COLS);
	      MagnitudeOut1->write(magnitude);
	      MagnitudeOut2->write(magnitude);
	      GradxOut_ByPass->write(Gradx_ByPass);
	      GradyOut_ByPass->write(Grady_ByPass);
	   }
	}

	SC_CTOR(Magnitude_X_Y)
	{
           SC_THREAD(main);
	}
};

SC_MODULE(Non_Max_Supp)
{
	sc_port<i_SIMAGE_receiver> GradxIn, GradyIn, MagIn, MagIn_ByPass;
	sc_port<i_IMAGE_sender> NmsOut;
	sc_port<i_SIMAGE_sender> MagOut_ByPass;
	SIMAGE gradx, grady, mag, mag_bp;
	IMAGE nms;

	void main(void)
	{
	   IMAGE result;

	   while(1)
	   {
	      GradxIn->read(gradx);
	      GradyIn->read(grady);
	      MagIn->read(mag);
	      MagIn_ByPass->read(mag_bp);
	      wait(272,SC_MS);
	      //non_max_supp(ROWS, COLS, result);
	      nms = result;
	      NmsOut->write(nms);
	      MagOut_ByPass->write(mag_bp);
	   }
	}

	SC_CTOR(Non_Max_Supp)
	{
           SC_THREAD(main);
	}
};

SC_MODULE(Apply_Hysteresis)
{
	sc_port<i_SIMAGE_receiver> MagIn;
	sc_port<i_IMAGE_receiver> NmsIn;
	sc_port<i_IMAGE_sender> ImgOut;
	SIMAGE mag;
	IMAGE nms, EdgeImage;

	void main(void)
	{
	   while(1)
	   {
	      MagIn->read(mag);
	      NmsIn->read(nms);
	      wait(196,SC_MS);
	      //apply_hysteresis(ROWS, COLS, TLOW, THIGH, EdgeImage);
	      ImgOut->write(EdgeImage);
	   }
	}

	SC_CTOR(Apply_Hysteresis)
	{
           SC_THREAD(main);
	}
};

SC_MODULE(DUT)
{
	sc_port<i_IMAGE_receiver> ImgIn;
	sc_port<i_IMAGE_sender> ImgOut;
	c_SIMAGE_fifo q1, q2, q3, q4, q5, q6, q7, q3_bp, q5_bp, q7_bp;
	c_IMAGE_fifo nms;

	Gaussian_Smooth gaussian_smooth;
	Derivative_X_Y derivative_x_y;
	Magnitude_X_Y magnitude_x_y;
	Non_Max_Supp non_max_supp;
	Apply_Hysteresis apply_hysteresis;

	void before_end_of_elaboration(){
	}

	SC_CTOR(DUT)
	:q1("q1",1)
	,q2("q2",1)
	,q3("q3",1)
	,q4("q4",1)
	,q5("q5",1)
	,q6("q6",1)
	,q7("q7",1)
	,q3_bp("q3_bp",1)
	,q5_bp("q5_bp",1)
	,q7_bp("q7_bp",1)
	,nms("nms",1)
	,gaussian_smooth("gaussian_smooth")
	,derivative_x_y("derivative_x_y")
	,magnitude_x_y("magnitude_x_y")
	,non_max_supp("non_max_supp")
	,apply_hysteresis("apply_hysteresis")
	{
	   gaussian_smooth.ImgIn.bind(ImgIn);
	   gaussian_smooth.SmoothedimOut.bind(q1);

           derivative_x_y.SmoothedimIn.bind(q1);
           derivative_x_y.XOut1.bind(q2);
           derivative_x_y.XOut2.bind(q3);
           derivative_x_y.YOut1.bind(q4);
           derivative_x_y.YOut2.bind(q5);

           magnitude_x_y.XIn.bind(q2);
           magnitude_x_y.YIn.bind(q4);
	   magnitude_x_y.GradxIn_ByPass(q3);
	   magnitude_x_y.GradyIn_ByPass(q5);
           magnitude_x_y.MagnitudeOut1.bind(q6);
           magnitude_x_y.MagnitudeOut2.bind(q7);
	   magnitude_x_y.GradxOut_ByPass(q3_bp);
	   magnitude_x_y.GradyOut_ByPass(q5_bp);

           non_max_supp.GradxIn.bind(q3_bp);
           non_max_supp.GradyIn.bind(q5_bp);
           non_max_supp.MagIn.bind(q6);
	   non_max_supp.MagIn_ByPass.bind(q7);
           non_max_supp.NmsOut.bind(nms);
	   non_max_supp.MagOut_ByPass.bind(q7_bp);

           apply_hysteresis.MagIn.bind(q7_bp);
           apply_hysteresis.NmsIn.bind(nms);
           apply_hysteresis.ImgOut.bind(ImgOut);
	}
};

SC_MODULE(Platform)
{
	sc_port<i_IMAGE_receiver> ImgIn;
	sc_port<i_IMAGE_sender> ImgOut;
	c_IMAGE_fifo q1;
	c_IMAGE_fifo q2;

	DataIn din;
	DUT canny;
	DataOut dout;

	void before_end_of_elaboration(){
	   din.ImgIn.bind(ImgIn);
	   din.ImgOut.bind(q1);
	   canny.ImgIn.bind(q1);
	   canny.ImgOut.bind(q2);
	   dout.ImgIn.bind(q2);
	   dout.ImgOut.bind(ImgOut);
	}

	SC_CTOR(Platform)
	:q1("q1",1)
	,q2("q2",1)
	,din("din")
	,canny("canny")
	,dout("dout")
	{}
};

SC_MODULE(Top)
{
	c_IMAGE_fifo q1;
	c_IMAGE_fifo q2;
	c_SCTIME_fifo qt;
	Stimulus stimulus;
	Platform platform;
	Monitor monitor;

	void before_end_of_elaboration(){
	   stimulus.ImgOut.bind(q1);
	   stimulus.StartTime.bind(qt);
	   platform.ImgIn.bind(q1);
	   platform.ImgOut.bind(q2);
	   monitor.ImgIn.bind(q2);
	   monitor.StartTime.bind(qt);
	}

	SC_CTOR(Top)
	:q1("q1",1)
	,q2("q2",1)
	,qt("qt",30)
	,stimulus("stimulus")
	,platform("platform")
	,monitor("monitor")
	{
	}
};

Top top("top");

int sc_main(int argc, char* argv[])
{
    sc_time expected_time(6109, SC_MS);
    printf("bug20190328 start.\n");
    sc_start();
    assert(sc_time_stamp() == expected_time);
    printf("bug20190328 done.\n");
    return 0;
}

// EOF
