#!/bin/bash

result=0
for i in golden_graphs/*.dot; do
    temp_filename=$(basename $i )

    match=0
    for alternative in $i*; do
        diff <(sort $alternative) <(sort $temp_filename) > /dev/null
        if [ "$?" = "0" ]; then
          match=1
        fi
    done

    if [ "$match" = "0" ]; then
      echo "No match for $temp_filename in $i*"
      result=1
    fi
done

for i in golden_graphs/*.html; do
    temp_filename=$(basename $i )

    diff <(sort $i) <(sort $temp_filename) > /dev/null

    if [ "$?" = "1" ]; then
      echo "$temp_filename and $i are different"
      result=1
    fi
done

if [ "$result" = "0" ]; then
  echo "Golden files match!"
  exit 0
else
  echo "Mismatch with golden files!"
  exit 1
fi

