// data_conflict3.cc:
//
// 04/26/19 RD	refined version for debugging RW-access analysis of conditions
//		(for reference see DEBUG in src/segment_graph/segment.cpp)
// 04/24/19 RD	initial version: BUG, omitted R-access for if(c){}

#include <stdio.h>
#include "systemc.h"

int	Global = 42;
int	*Ptr = 0;

class i_transceiver: virtual public sc_interface
{
    public:
	virtual int read(void) = 0;
	virtual void write(const int) = 0;
};

class c_double_handshake_channel:
	public sc_channel, public i_transceiver
{
    public:
	c_double_handshake_channel(sc_module_name name):
		sc_channel(name)
	{
	    v = false;
	    w = false;
	}

	~c_double_handshake_channel()
	{ }

	int read(void)			// part of Seg 5
	{
	    if (!v)	// works
	    {
		w = true;
		wait(req);
		w = false;
	    }
	    int temp = tmpd;
	    v = false;
	    v2 = false;
	    v3 = false;
	    v4 = false;
	    v5 = false;
	    v6 = false;
	    ack.notify(SC_ZERO_TIME);
	    while(v2)	// additional test 1
		{ }
	    do { }	// additional test 2
		while(v3);
	    for(int i=0; v4; i++)	// additional test 3
		{ }
	    switch(v5)	// additional test 4
	    { case true: { break; }
	      default: { }
	    }
	    if(v6)	// additional test 5
		{ }
	    else
		{ }
	    wait(ack);
	    return temp;// works
	}

	void write(const int X)		// part of Seg 4
	{
	    tmpd = X;
	    v = true;
	    if (w)	// BUG! READ-ACCESS OMITTED!
	    {		// (appears only in cloned SG expressions!?)
		req.notify(SC_ZERO_TIME);
	    }
	    wait(ack);
	}

    private:
	sc_event req;
	sc_event ack;
	bool v, w;
	bool v2, v3, v4, v5, v6;
	int tmpd;
};

class Mod : public sc_module
{
    public:
	sc_port<i_transceiver> Port;
	int Member;
	static int Static;

	void T()
	{
		bool Local;	// notice 'bool' type!

		Local  = Global;	// SegID 0
		Member = Local;//(42 becomes true becomes 1)
		Ptr = &Global;

		wait(1, SC_NS);		// SegID 1
		Global = Member;
		Static++;

		wait(1, SC_NS);		// SegID 2
		if (Local)	// READ-ACCESS MISSING (no surrounding operator)
		{ Global = 0; }
		if (Static)	// READ-ACCESS FOUND (because of implied cast-operator!)
		{ Global = 1; }
		if (Member)	// READ-ACCESS FOUND (because of surrounding ->operator)
		    Global = 2;

		wait(1, SC_NS);		// SegID 3
		if (!Local)	// READ-ACCESS FOUND (because of surrounding !operator)
		{ Global = 3; }
		if (!Static)
		{ Global = 4; }
		if (!Member)
		{ Global = 5; }

		wait(1, SC_NS);		// SegID 4
		int p;
		Port->write(p);

		int loop = 0;		// SegID 5
		while(loop)
		{ Port->read(); }	// SegID 6 and 7

		int EndOfThread = 42;
	}

	Mod(sc_module_name name) : sc_module(name)
	{
		Member = 0;
		SC_THREAD(T);
	}
	SC_HAS_PROCESS(Mod);
};

int Mod::Static = 0;

SC_MODULE(TOP)
{
    c_double_handshake_channel c;
    Mod m1;

    SC_CTOR(TOP)
    : c("c"), m1("m1")
    {
    }

    void before_end_of_elaboration()
    {
	m1.Port.bind(c);
    }
};

TOP top("top");

int sc_main(int argc, char* argv[])
{
    printf("data_conflict3 starts\n");
    sc_start();
    assert(Global==2);
    assert(Ptr==&Global);
    assert(top.m1.Member==1);
    assert(top.m1.Static==1);
    printf("data_conflict3 done\n");
    return 0;
}

// EOF
